/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.tpslimit;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.command.SWCommand;
import de.steamwar.core.TPSWatcher;
import de.steamwar.linkage.Linked;
import de.steamwar.linkage.LinkedInstance;
import org.bukkit.entity.Player;

@Linked
public class TPSCommand extends SWCommand {

    @LinkedInstance
    public TPSSystem tpsSystem;

    public TPSCommand() {
        super("tps");
        unregister();
        register();
    }

    @Register
    public void genericCommand(Player p, String... args) {
        BauSystem.MESSAGE.sendPrefixless("OTHER_TPS_HEAD", p);
        BauSystem.MESSAGE.sendPrefixless("OTHER_TPS_MESSAGE", p,
                TPSWatcher.getTPS(TPSWatcher.TPSType.ONE_SECOND),
                TPSWatcher.getTPS(TPSWatcher.TPSType.TEN_SECONDS),
                TPSWatcher.getTPS(TPSWatcher.TPSType.ONE_MINUTE),
                TPSWatcher.getTPS(TPSWatcher.TPSType.FIVE_MINUTES),
                TPSWatcher.getTPS(TPSWatcher.TPSType.TEN_MINUTES)
        );
    }

    @Register
    public void genericCommand(Player p, TPSWatcher.TPSType type) {
        BauSystem.MESSAGE.sendPrefixless("OTHER_TPS_SINGLE", p, tpsSystem.getTPS(type));
    }
}
